# Maintainer: anon at sansorgan.es
_name=dune-common
pkgbase="${_name}-git"
pkgname=(${pkgbase} python-${pkgbase})
_gitcommit=cd1c40dbcb849904b3a0e3a60e310d57d712eac1
_gitcommit_tests=bda00b8d82c9106a939e2aff6e04059c19933d09
pkgver=2021.10.r1.cd1c40d
pkgrel=1
#epoch=
pkgdesc="Common components for OPM, in particular build system"
arch=('x86_64')
url="https://github.com/OPM/${pkgname}"
license=('GPL3')
groups=('opm')
depends=('dune-common-git' 'boost')
makedepends=('dune-common-git' 'cppcheck' 'suitesparse' 'texlive-core' 'doxygen' 'graphviz' 'openmpi' 'cjson' 'fmt' 'git') # 'mpich' 'python-sphinx'
#checkdepends=()
# optdepends=()
provides=('compareECL' 'convertECL' 'make_lodsmry' 'opmhash' 'opmi' 'opmpack' 'rewriteEclFile' 'summary')
#conflicts=()
#replaces=()
#backup=()
#options=()
#install=
#changelog=
source=(${pkgname}.opts "git+${url}#commit=${_gitcommit}" "git+${url//common/tests}#commit=${_gitcommit_tests}")
#noextract=()
sha512sums=('' '' 'SKIP')

pkgver() {
  cd "${_name}"
  printf "2021.10.r%s.%s" "$(git rev-list --count HEAD)" "$(git rev-parse --short HEAD)"
}

prepare() {
  # https://github.com/OPM/opm-common/blob/master/opm/io/eclipse/SummaryNode.hpp#L22
  sed -i '22 a #include <limits>' ${pkgname}-release-${pkgver}-final/opm/io/eclipse/SummaryNode.hpp
  # https://github.com/OPM/opm-common/blob/master/opm/parser/eclipse/EclipseState/Grid/Keywords.hpp#L23
  sed -i '22 a #include <optional>' ${pkgname}-release-${pkgver}-final/opm/parser/eclipse/EclipseState/Grid/Keywords.hpp
  sed -i '22 a #include <limits>' ${pkgname}-release-${pkgver}-final/opm/parser/eclipse/EclipseState/Grid/Keywords.hpp
  # https://github.com/OPM/opm-common/blob/master/opm/parser/eclipse/EclipseState/Schedule/Well/NameOrder.hpp#L22
  sed -i '22 a #include <optional>' ${pkgname}-release-${pkgver}-final/opm/parser/eclipse/EclipseState/Schedule/Well/NameOrder.hpp
  # https://github.com/OPM/opm-common/blob/master/opm/output/eclipse/Inplace.hpp#L22
  sed -i '22 a #include <optional>' ${pkgname}-release-${pkgver}-final/opm/output/eclipse/Inplace.hpp
  #sed -i 's/^option(OPM_ENABLE_PYTHON "Enable python bindings?" OFF)/option(OPM_ENABLE_PYTHON "Enable python bindings?" ON)/' ${pkgname}-release-${pkgver}-final/CMakeLists.txt
  #sed -i 's/^option(OPM_INSTALL_PYTHON "Enable python bindings?" OFF)/option(OPM_INSTALL_PYTHON "Enable python bindings?" ON)/' ${pkgname}-release-${pkgver}-final/CMakeLists.txt
  #sed -i 's/^option(OPM_ENABLE_EMBEDDED_PYTHON "Enable embedded python?" OFF)/option(OPM_ENABLE_EMBEDDED_PYTHON "Enable embedded python?" ON)/' ${pkgname}-release-${pkgver}-final/CMakeLists.txt
}

build() {
  dunecontrol --opts=${pkgname}.opts cmake -Wno-dev : make
  #-DBUILD_SHARED_LIBS=1
  #-DCMAKE_INSTALL_DOCDIR=share/doc/libopm-common1
  #-DWHOLE_PROG_OPTIM=ON
  #-DOPM_ENABLE_PYTHON=1 -DOPM_INSTALL_PYTHON=1
  #-DOPM_ENABLE_EMBEDDED_PYTHON=1
}

# build() {
#   cmake \
#     -S ${pkgname}-release-${pkgver}-final \
#     -B build-cmake \
#     -DCMAKE_BUILD_TYPE=None \
#     -DCMAKE_INSTALL_PREFIX=/usr \
#     -DCMAKE_CXX_STANDARD=17 \
#     -DBUILD_SHARED_LIBS=1 \
#     -DCMAKE_CXX_FLAGS=" \
#     -std=c++17 \
#     -O2 -g \
#     -Wall \
#     -fdiagnostics-color=always" \
#     -DUSE_MPI=1 \
#     -Wno-dev
#   cmake --build build-cmake --target help #all
# }
# -DCMAKE_PREFIX_PATH=/usr/include/dune \

check() {
  dunecontrol --opts=${pkgname}.opts make tests
  cd "${pkgname}-release-${pkgver}-final/build-cmake"
  dune-ctest --verbose --output-on-failure
}

package() {
  dunecontrol --only=${pkgname} make install install-html DESTDIR="${pkgdir}" #EmbeddedPython
  # DESTDIR="${pkgdir}" cmake --build build-cmake --target install
  install -Dm644 ${pkgname}-release-${pkgver}-final/LICENSE "${pkgdir}/usr/share/licenses/${pkgname}/LICENSE"
  find "${pkgdir}" -type d -empty -delete
}
